clear all
close all

SARSA=1;        %flag
TD_control=0;   %flag
population=1;
time=100000;
e=0.1;
alpha=0.05;
if SARSA ==1
    gamma=2.5;
else
    gamma=0.9;
end
temp=1;
action=zeros(time,population);
rew=zeros(time,population);

%ones(1,4)/4;
%vectors for X-Y coordinates and starting point

for p=1:population
    close all
    trial=0;
    position=zeros(time,2);
    c1=zeros(time,1);
    c2=zeros(time,1);
    position(1,:)=[1 1];
    c1(1)=position(1,1);
    c2(1)=position(1,2);
    fig=figure('Name', 'CLIFF_TASK', 'Position', [100 200 1400 600]);
    arena_builder_cliff
    h = hgtransform('Parent',gca);
    build_Qasv_start
    %load('q_function_cliff_SARSA.mat')
    %load('q_function_cliff_TD')
    for iir=1:10
        for iic=1:10
            mean_q(iir,iic)=mean(Qasv_s((iir-1)*10+iic,3:6));
        end
    end

    for i=2:time
        %i
        %wait(25)
        
        %determine behavior
        if rand(1)<=e                                          %random exploration
            action(i,p)=randi(4); 
        else                                                   %SOFTMAX exploration
            %[a action(i,p)]=max(Qasv_s((position(i,1)-1)*(10)+position(i,2),3:6));
            sms1=softmaxselection(Qasv_s((position(i-1,1)-1)*(10)+position(i-1,2),3:6), temp);
            action(i,p)=sms1{1};
        end
        
        %compute position
        if position(i-1,2)==1 && position(i-1,1)>1 && position(i-1,1)<10 %falling in the cliff  
            position(i,1)=1;
            position(i,2)=1;
            trial=1;
        elseif position(i-1,1)==10 && position(i-1,2)==1                 %goal reached
            position(i,1)=1;
            position(i,2)=1;
            trial=1;
        elseif action(i,p)==1
            position(i,1)=min(10, position(i-1,1)+1);
            position(i,2)=position(i-1,2);
        elseif action(i,p)==2
            position(i,1)=position(i-1,1);
            position(i,2)=min(5, position(i-1,2)+1);
        elseif action(i,p)==3
            position(i,1)=max(1, position(i-1,1)-1);
            position(i,2)=position(i-1,2);
        elseif action(i,p)==4
            position(i,1)=position(i-1,1);
            position(i,2)=max(1, position(i-1,2)-1);
        end
                
        %compute reward        
        if position(i-1,1)==10 && position(i-1,2)==1 
            rew(i,p)=15;
            ev=strcat('REWARD, i:',num2str(i));
            disp(ev)
        elseif position(i-1,1)>1 && position(i-1,1)<10 && position(i-1,2)==1
            rew(i,p)=-100;
            ev=strcat('fall,   i:',num2str(i));
            disp(ev)
        elseif trial==1
            rew(i,p)=0;
            trial=0;
        else
            rew(i,p)=-1;
        end
        %rew(i)
        
        %compute value
        if SARSA==1 && TD_control==1   
            error('both sarsa and TD update flags are active');        
        elseif SARSA==1
            %SARSA update
            sms2=softmaxselection(Qasv_s((position(i,1)-1)*(10)+position(i,2),3:6),temp);
            sarsaval=e*(mean(Qasv_s((position(i,1)-1)*(10)+position(i,2),3:6))) + (1-e)*sms2{3};
            Qasv_s((position(i-1,1)-1)*(10)+position(i-1,2), action(i,p)+2)= ...
                    Qasv_s((position(i-1,1)-1)*(10)+position(i-1,2), action(i,p)+2) + alpha*(rew(i,p) + ...
                    gamma*(sarsaval) - Qasv_s((position(i-1,1)-1)*(10)+position(i-1,2), action(i,p)+2));

            sms3=softmaxselection(Qasv_s((position(i-1,1)-1)*(10)+position(i-1,2),3:6),temp);
            mean_q(position(i-1,1),position(i-1,2))=max(-10, ...
                e*(mean(Qasv_s((position(i-1,1)-1)*(10)+position(i-1,2),3:6))) + (1-e)*sms3{3});
            
            %Off-policy TD control    
        elseif TD_control==1
            Qasv_s((position(i-1,1)-1)*(10)+position(i-1,2), action(i,p)+2)= ...
                    Qasv_s((position(i-1,1)-1)*(10)+position(i-1,2), action(i,p)+2) + alpha*(rew(i,p) + ...
                    gamma*max(Qasv_s((position(i,1)-1)*(10)+position(i,2),3:6)) - ...
                    Qasv_s((position(i-1,1)-1)*(10)+position(i-1,2), action(i,p)+2)); 
            
            mean_q(position(i-1,1),position(i-1,2))=max(Qasv_s((position(i-1,1)-1)*(10)+position(i-1,2),3:6));
                
        elseif SARSA==0 && TD_control==0        
            error('neither SARSA nor TD update flags are active');       
        end

        c1(i)=position(i,1);
        c2(i)=position(i,2);
        subplot(1,2,2)
        plot(-0.5,-0.5,'o','LineWidth', 4, 'color', 'm','MarkerSize', 15,'MarkerFaceColor', 'b', 'Parent',h)
        m1 = makehgtform('translate',c1(i),c2(i),0);
        h.Matrix = m1;
        %t1;
        t10.String = ['coordinates: ', num2str([c1(i) c2(i)])];
        t11.String = ['reward: ', num2str(rew(i,p))];
        subplot (1,2,1)
        imagesc(max(-15, mean_q)','YData', [5 1])
        axis ([0.5 10.5 3 5.2])
        set(gca,'YTick',[])
        set(gca,'XTick',[])
        if i<1000  
            drawnow
        elseif i>time-1  
            drawnow
        end
%     action(i,:)
%     position(i,:)
%     rew(i,:)    
%     Qasv_s((position(i-1,1)-1)*(10)+position(i-1,2), :)
    end

end
